chisq.test <- function(x, y = NULL, correct = TRUE, p = rep(1/length(x), length(x)), rescale.p = FALSE,
                       simulate.p.value = FALSE, B = 2000, interactive = FALSE)
{
  if (interactive == FALSE && !missing(x))
  {
    out = list()
  
    result = try(stats::chisq.test(x, y, correct, p, rescale.p, simulate.p.value, B), silent = TRUE) #performs the test in third party function
    if (!is.null(attr(result, "class")))
    {
      if ((attr(result, "class") == "try-error") == TRUE)
      {
        return(result)
      }
    }
    out$test.statistic <- as.numeric(result$statistic)
    out$p.value <- result$p.value
    out$df <- as.numeric(result$parameter)
    out$observed <- as.numeric(result$observed)
    out$expected <- as.numeric(result$expected)
    out$residuals <- as.numeric(result$residuals)
    out$standard.residuals <- as.numeric(result$stdres)
  
    return(out) #out: out$test.statistic, p.value, df, observed, expected, residuals, standard.residuals
  } else
  {
    out = execute.cli("chisq.test")
    return(out)
  }
}
