chisq.test.gui <- function()
{
  out = NULL
  
  text.entry <- function()
  {
    ok <- function() ######### gets user input
    {
      ## MUST USE NAMES IN RETURNVAL FOR DO.CALL
      returnval$x <<- tclvalue(x)
      returnval$y <<- tclvalue(y)
      returnval$correct <<- tclvalue(correct)
      returnval$p <<- tclvalue(p)
      returnval$rescale.p <<- tclvalue(rescale.p)
      returnval$simulate.p.value <<- tclvalue(simulate.p.value)
      returnval$B <<- tclvalue(B)
      
      eval = list()
      
      for (i in seq(7))
      {
        eval[[i]] = list()
      }
      
      eval[[1]] = vector.gui(returnval$x)
      eval[[2]] = vector.optional.gui(returnval$y)
      eval[[3]] = logical.optional.gui(returnval$correct)
      eval[[4]] = vector.optional.gui(returnval$p)
      eval[[5]] = logical.gui(returnval$rescale.p)
      eval[[6]] = logical.optional.gui(returnval$simulate.p.value)
      eval[[7]] = integer.optional.gui(returnval$B)
      
      if (is.null(eval[[5]]$value))
      {
        eval[[5]]$value = FALSE
      }
      
      if (eval[[4]]$loop == FALSE && !is.null(eval[[4]]$value && eval[[5]]$value == FALSE))
      # make sure all probs between 0 and 1
      {
        for (i in seq(length(eval[[4]]$value)))
        {
          if (eval[[4]]$value[i] > 1 || eval[[4]]$value[i] < 0)
          {
            eval[[4]]$loop = TRUE
            break
          }
        }
      }
      
      for (i in seq(7))
      {
        if (eval[[i]]$loop == TRUE) ###### NOTE: Do not use tkdestroy() here because that will cancel the wait, which prevents data re-entry
        {
          errorText = paste("Something is wrong in argument number ", i,
                            " . Note that some fields, including optional fields. are dependent on others. ", sep = "")
          tkmessageBox(message = errorText, icon = "error")
          returnval <<- NULL
          break
        }
      }
      
      if (!is.null(returnval))
      {
        if (!(returnval[1] == "Cancel"))
        {
          returnval$x <<- eval[[1]]$value
          returnval$y <<- eval[[2]]$value
          returnval$correct <<- eval[[3]]$value
          returnval$p <<- eval[[4]]$value
          returnval$rescale.p <<- eval[[5]]$value
          returnval$simulate.p.value <<- eval[[6]]$value
          returnval$B <<- eval[[7]]$value
          
          tkdestroy(win)
        }
      }
      
    }
    
    cancel <- function() ######## cancels
    {
      returnval[1] <<- "Cancel"
      
      tkdestroy(win)
    }
    
    ###################################################### creating the window
    
    win = tktoplevel()
    tkwm.title(win, "chisq.test")
    tkwm.geometry(win, "+100+100")
    
    x = tclVar(paste("")) #v in Var is capital
    text.x = ttkentry(win, width = paste(50), textvariable = x)
    
    y = tclVar(paste(""))
    text.y = ttkentry(win, width = paste(50), textvariable = y)
    
    correct = tclVar(paste("TRUE"))
    text.correct = ttkentry(win, width = paste(10), textvariable = correct)
    
    p = tclVar(paste(""))
    text.p = ttkentry(win, width = paste(50), textvariable = p)
    
    rescale.p = tclVar(paste("FALSE"))
    text.rescale.p = ttkentry(win, width = paste(10), textvariable = rescale.p)
    
    simulate.p.value = tclVar(paste("FALSE"))
    text.simulate.p.value = ttkentry(win, width = paste(10), textvariable = simulate.p.value)
    
    B = tclVar(paste("2000"))
    text.B = ttkentry(win, width = paste(20), textvariable = B)
    
    tkgrid(ttklabel(win, text = "1. A Numeric Vector of the Data: "), text.x, sticky = "we")
    tkgrid(ttklabel(win, text = "2. A Numeric Vector of the Second Data (Optional): "), text.y, sticky = "we")
    tkgrid(ttklabel(win, text = "3. Do you want to apply Continutiy Correction (Optional)? "), text.correct, sticky = "we")
    tkgrid(ttklabel(win, text = "4. A Numeric Vector of the Probabilities (Optional): "), text.p, sticky = "we")
    tkgrid(ttklabel(win, text = "5. Do you want to Rescale the Probabilities to sum to 1? "), text.rescale.p, sticky = "we")
    tkgrid(ttklabel(win, text = "6. Do you want to Simulate the P Value (Optional)? "), text.simulate.p.value, sticky = "we")
    tkgrid(ttklabel(win, text = "7. The number of replicates the Monte Carlo Simulation uses (Optional): "), text.B, sticky = "we")
    
    ok.button = ttkbutton(win, text = "Ok", command = ok)
    cancel.button = ttkbutton(win, text = "Cancel", command = cancel)
    
    tkgrid(ok.button, cancel.button, sticky = "we")
    
    returnval = list()
    
    tkfocus(win)
    tkwait.window(win)
    return(returnval)
  }
  
  ##################################### getting user input
  value = text.entry()
  
  ############### cancel action
  if (value[[1]] == "Cancel")
  {
    return(FALSE)
  }
  
  result = do.call(HypoTest::chisq.test, value)
  
  out <<- result
  
  print(result)
}