execute.gui <- function()
{
  enableJIT(3)
  
  main.gui <- function()
  {
    #################### Statistic: Mean ############################################
    mean <- function()
    {
      tkdestroy(mainWindow)
      
      ########################### Number Samples: 1 or 2
      sample12 <- function()
      {
        
        ############################## Sigma Known
        known <- function()
        {
          ########################## Data
          data <- function()
          {
            tkdestroy(knownWindow)
            
            out <<- z.test.gui()
          }
          
          ############################ Summary stats ######### zsum.test
          summary <- function()
          {
            tkdestroy(knownWindow)
            
            out <<- zsum.test.gui()
          }
          ################################ Sigma Known Window
          tkdestroy(sample12Window)
          
          knownWindow = tktoplevel()
          tkwm.title(knownWindow, "Sigma Known")
          tkwm.geometry(knownWindow, "+100+100")
          
          data.button = ttkbutton(knownWindow, text = "Data", command = data)
          summary.button = ttkbutton(knownWindow, text = "Summary Stats", command = summary)
          back.button = ttkbutton(knownWindow, text = "Back", command = sample12)
          
          tkgrid(data.button, summary.button, sticky = "we")
          tkgrid(back.button, sticky = "we", columnspan = 2)
          
          tkfocus(knownWindow)
          tkwait.window(knownWindow)
          
        }
        
        ############################## Sigma Unknown
        unknown <- function()
        {
          ########################## Data
          data <- function()
          {
            tkdestroy(unknownWindow)
            
            out <<- t.test.gui()
          }
          
          ############################ Summary stats
          summary <- function()
          {
            tkdestroy(unknownWindow)
            
            out <<- tsum.test.gui()
          }
          ################################ Sigma Unknown Window
          tkdestroy(sample12Window)
          
          unknownWindow = tktoplevel()
          tkwm.title(unknownWindow, "Sigma Unknown")
          tkwm.geometry(unknownWindow, "+100+100")
          
          data.button = ttkbutton(unknownWindow, text = "Data", command = data)
          summary.button = ttkbutton(unknownWindow, text = "Summary Stats", command = summary)
          back.button = ttkbutton(unknownWindow, text = "Back", command = sample12)
          
          tkgrid(data.button, summary.button, sticky = "we")
          tkgrid(back.button, sticky = "we", columnspan = 2)
          
          tkfocus(unknownWindow)
          tkwait.window(unknownWindow)
        }
        
        ########################### Sample 1 or 2 window
        
        tkdestroy(meanWindow)
        
        sample12Window = tktoplevel()
        tkwm.title(sample12Window, "1 or 2 Sample")
        tkwm.geometry(sample12Window, "+100+100")
        
        sigmaKnown.button = ttkbutton(sample12Window, text = "Sigma Known", command = known)
        sigmaUnknown.button = ttkbutton(sample12Window, text = "Sigma Unknown", command = unknown)
        back.button = ttkbutton(sample12Window, text = "Back", command = mean)
        
        tkgrid(sigmaKnown.button, sigmaUnknown.button, sticky = "we")
        tkgrid(back.button, sticky = "we", columnspan = 2)
        
        tkfocus(sample12Window)
        tkwait.window(sample12Window)
        
      }
      ########################### Number Samples: Many
      sampleMany <- function()
      {
        tkdestroy(meanWindow)
        tkmessageBox(message = "The aov function is only supported in the command line interface mode. Please switch to the console to begin.
Caution: Cancelling during the command line session may cause instability and the R session may crash.")
        assign("out", execute.cli("aov"), envir = .GlobalEnv)
      }
      
      ################ Mean Window
      
      # tkmessageBox(message = "In Mean")
      meanWindow = tktoplevel()
      tkwm.title(meanWindow, "Mean")
      tkwm.geometry(meanWindow, "+100+100")
      
      sample12.button = ttkbutton(meanWindow, text = "1 or 2 Samples", command = sample12)
      sampleMany.button = ttkbutton(meanWindow, text = "Many Samples", command = sampleMany)
      back.button = ttkbutton(meanWindow, text = "Back", command = main.gui)
      
      tkgrid(sample12.button, sampleMany.button, stick = "we")
      tkgrid(back.button, sticky = "we", columnspan = 2)
      
      tkfocus(meanWindow)
      tkwait.window(meanWindow)
    }
    ################################# Statistic: Variance ################################################
    variance <- function()
    {
      
      ################ 1 sample, sigma
      sigma <- function()
      {
        # sigma.test
        data <- function()
        {
          tkdestroy(sigmaWindow)
          
          out <<- sigma.test.gui()
        }
        
        # sigmasum.test
        summary <- function()
        {
          tkdestroy(sigmaWindow)
          
          out <<- sigmasum.test.gui()
        }
        
        ######## Data versus summary stat window
        
        tkdestroy(varianceWindow)
        
        sigmaWindow = tktoplevel()
        tkwm.title(sigmaWindow, "1 Sample Variance")
        tkwm.geometry(sigmaWindow, "+100+100")
        
        data.button = ttkbutton(sigmaWindow, text = "Data", command = data)
        summary.button = ttkbutton(sigmaWindow, text = "Summary Stats", command = summary)
        back.button = ttkbutton(sigmaWindow, text = "Back", command = variance)
        
        tkgrid(data.button, summary.button, sticky = "we")
        tkgrid(back.button, sticky = "we", columnspan = 2)
        
        tkfocus(sigmaWindow)
        tkwait.window(sigmaWindow)
      }
      
      
      ################## 2 sample, var
      var <- function()
      {
        # var.test
        data <- function()
        {
          tkdestroy(varWindow)
          
          out <<- var.test.gui()
        }
        
        # varsum.test
        summary <- function()
        {
          tkdestroy(varWindow)
          
          out <<- varsum.test.gui()
        }
        
        ######## Data versus summary stat window
        
        tkdestroy(varianceWindow)
        
        varWindow = tktoplevel()
        tkwm.title(varWindow, "2 Sample Variance")
        tkwm.geometry(varWindow, "+100+100")
        
        data.button = ttkbutton(varWindow, text = "Data", command = data)
        summary.button = ttkbutton(varWindow, text = "Summary Stats", command = summary)
        back.button = ttkbutton(varWindow, text = "Back", command = variance)
        
        tkgrid(data.button, summary.button, sticky = "we")
        tkgrid(back.button, sticky = "we", columnspan = 2)
        
        tkfocus(varWindow)
        tkwait.window(varWindow)
        
      }
      
      
      ########### Variance Statistic Window
      
      tkdestroy(mainWindow)
      
      varianceWindow = tktoplevel()
      tkwm.title(varianceWindow, "Variance")
      tkwm.geometry(varianceWindow, "+100+100")
      
      sigma.button = ttkbutton(varianceWindow, text = "1 Sample (Sigma)", command = sigma)
      var.button = ttkbutton(varianceWindow, text = "2 Sample (Var)", command = var)
      back.button = ttkbutton(varianceWindow, text = "Back", command = main.gui)
      
      tkgrid(sigma.button, var.button, sticky = "we")
      tkgrid(back.button, sticky = "we", columnspan = 2)
      
      tkfocus(varianceWindow)
      tkwait.window(varianceWindow)
    }
    
    distro <- function()
    {
      tkdestroy(mainWindow)
      
      out <<- ks.test.gui()
    }
    
    indep <- function()
    {
      tkdestroy(mainWindow)
      
      out <<- chisq.test.gui()
    }
    
    prop <- function()
    {
      sample1 <- function()
      {
        small <- function()
        {
          tkdestroy(sample1Window)
          
          out <<- binom.test.gui()
        }
        
        large <- function()
        {
          tkdestroy(sample1Window)
          
          out <<- prop.test.gui()
        }
        
        tkdestroy(propWindow)
        sample1Window = tktoplevel()
        tkwm.title(sample1Window, "1 Sample")
        tkwm.geometry(sample1Window, "+100+100")
        
        small.button = ttkbutton(sample1Window, text = "Small Sample Data", command = small)
        large.button = ttkbutton(sample1Window, text = "Large Sample Data", command = large)
        back.button = ttkbutton(sample1Window, text = "Back", command = prop)
        
        tkgrid(small.button, large.button, sticky = "we")
        tkgrid(back.button, sticky = "we", columnspan = 2)
        
        tkfocus(sample1Window)
        tkwait.window(sample1Window)
      }
      
      sample2 <- function()
      {
        indep <- function()
        {
          tkdestroy(sample2Window)
          
          out <<- prop.test.gui()
        }
        
        dep <- function()
        {
          tkdestroy(sample2Window)
          
          out <<- mcnemar.test.gui()
        }
        
        tkdestroy(propWindow)
        
        sample2Window = tktoplevel()
        tkwm.title(sample2Window, "2 Sample")
        tkwm.geometry(sample2Window, "+100+100")
        
        indep.button = ttkbutton(sample2Window, text = "Independent Data", command = indep)
        dep.button = ttkbutton(sample2Window, text = "Dependent Data", command = dep)
        back.button = ttkbutton(sample2Window, text = "Back", command = prop)
        
        tkgrid(indep.button, dep.button, sticky = "we")
        tkgrid(back.button, sticky = "we", columnspan = 2)
        
        tkfocus(sample2Window)
        tkwait.window(sample2Window)
      }
      
      many <- function()
      {
        tkdestroy(propWindow)
        
        out <<- chisq.test.gui()
      }
      
      tkdestroy(mainWindow)
      propWindow = tktoplevel()
      tkwm.title(propWindow, "Proportion")
      tkwm.geometry(propWindow, "+100+100")
      
      sample1.button = ttkbutton(propWindow, text = "1 Sample", command = sample1)
      sample2.button = ttkbutton(propWindow, text = "2 Sample", command = sample2)
      sampleMany.button = ttkbutton(propWindow, text = "Many Sample", command = many)
      back.button = ttkbutton(propWindow, text = "Back", command = main.gui)
      
      tkgrid(sample1.button, sample2.button, sampleMany.button, sticky = "we")
      tkgrid(back.button, sticky = "we", columnspan = 3)
      
      tkfocus(propWindow)
      tkwait.window(propWindow)
      
    }
    
    fit <- function()
    {
      prob <- function()
      {
        tkdestroy(fitWindow)
        
        out <<- chisq.test.gui()
      }
      
      noprob <- function()
      {
        tkdestroy(fitWindow)
        
        out <<- goodfit.predict.gui()
      }
      
      tkdestroy(mainWindow)
      
      fitWindow = tktoplevel()
      tkwm.title(fitWindow, "Fitness")
      tkwm.geometry(fitWindow, "+100+100")
      
      prob.button = ttkbutton(fitWindow, text = "Probabilities Given", command = prob)
      noprob.button = ttkbutton(fitWindow, text = "Probabilities Not Given", command = noprob)
      back.button = ttkbutton(fitWindow, text = "Back", command = main.gui)
      
      tkgrid(prob.button, noprob.button, sticky = "we")
      tkgrid(back.button, sticky = "we", columnspan = 2)
      
      tkfocus(fitWindow)
      tkwait.window(fitWindow)
    }
    
    reg <- function()
    {
      tkdestroy(mainWindow)
      tkmessageBox(message = "The lm function is only supported in the command line interface mode. Please switch to the console to begin.
Caution: Cancelling during the command line session may cause instability and the R session may crash.")
      assign("out", execute.cli("lm"), envir = .GlobalEnv)
    }
    
    ############################## Main Window
    mainWindow = tktoplevel()
    tkwm.title(mainWindow, "Function Options")
    tkwm.geometry(mainWindow, "+50+100")
    
    mean.button = ttkbutton(mainWindow, text = "Mean", command = mean)
    variance.button = ttkbutton(mainWindow, text = "Variance", command = variance)
    distro.button = ttkbutton(mainWindow, text = "Distribution", command = distro)
    indep.button = ttkbutton(mainWindow, text = "Independence", command = indep)
    prop.button = ttkbutton(mainWindow, text = "Proportion", command = prop)
    fit.button = ttkbutton(mainWindow, text = "Fitness", command = fit)
    reg.button = ttkbutton(mainWindow, text = "Regression", command = reg)
    cancel.button = ttkbutton(mainWindow, text = "Cancel", command = function() {tkdestroy(mainWindow)
      cancel()}) #enter key between tkdestroy(mainWindow) and cancel
    
    tkgrid(ttklabel(mainWindow, text = "Quantitative Data:"), mean.button, variance.button, sticky = "we")
    tkgrid(ttklabel(mainWindow, text = "Categorical Data:"), prop.button, indep.button, fit.button, sticky = "we")
    tkgrid(ttklabel(mainWindow, text = "Pattern Matching:"), distro.button, reg.button, sticky = "we")
    tkgrid(cancel.button, sticky = "we", columnspan = 4)
    
    tkfocus(mainWindow)
    tkwait.window(mainWindow)
  }
  out = NULL
  ok <- function()
  {
    tkdestroy(warningWindow)
    out <<- NULL
    main.gui()
  }
  
  cancel <- function()
  {
    tkdestroy(warningWindow)
    print("User cancelled.")
  }
  
  warningWindow = tktoplevel()
  tkwm.title(warningWindow, "Global Variable Creation")
  
  ok.button = ttkbutton(warningWindow, text = "Continue", command = ok)
  cancel.button = ttkbutton(warningWindow, text = "Abort", command = cancel)
  
  tkgrid(ttklabel(warningWindow, text = "Warning: A Global Variable named \"out\" will be created."),
         columnspan = 2, sticky = "we")
  
  tkgrid(ttklabel(warningWindow, text = "        Any variable with this name will be replaced.    "), 
         columnspan = 2, sticky = "we")
  
  tkgrid(ok.button, cancel.button, sticky = "we")
  
  tkfocus(warningWindow)
  tkwait.window(warningWindow)
}