factor.prompt <- function(prompt = NULL)
{
  if (missing(prompt))
  {
    prompt = "Building a factor: "
  }
  
  writeLines("")
  writeLines("You can either create your own factor or use one in the global environment. ")
  writeLines("")
  writeLines(paste("For this factor: ", prompt, sep = ""))
  global = logical.prompt("Do you want to use a factor in the global environment? ")
  cat("\014")
  writeLines("")
  manual = TRUE
  
  while(global)
  {
    out <- global.env(prompt)
    if (is.factor(out)) #no problems
    {
      global = FALSE
      manual = FALSE
    } else
    {
      writeLines("There is a problem with the value specified.")
      global = logical.prompt("Do you want to try again? ")
      writeLines("")
    }
  }
  
  if (manual) #there was either a problem or we are creating manually
  {
    writeLines("We need a vector of values to make a factor")
    x = vector.prompt(prompt)
    writeLines("")
    writeLines(paste("For this: ", prompt, sep = ""))
    logic = logical.prompt("Do you want to specify the levels of this factor? ")
  
    if (logic)
    {
      levels = vector.prompt("Enter the levels: ")
      while (length(levels) != length(x))
      {
        writeLines(paste("Warning: Length of levels not equal to length of factor values: ", length(x), ". ", sep = ""))
        levels = vector.prompt("Enter the levels: ")
      }
      out <- factor(x, levels)
    } else
    {
      out <- factor(x)
    }
  }
  return(out)
}