global.env <- function(prompt = NULL)
{
  if (missing(prompt))
  {
    prompt = ""
  }
  
  skip = FALSE
  loop = TRUE
  env_list = ls(.GlobalEnv) #get the global environment stuff
  
  while(loop) #for re-trying
  {
    writeLines("")
    label = readline(paste("Enter the name of the value in the global envirnoment: ", prompt)) #get the name of what we want
    cat("\014")
  
    for (i in seq(length(env_list))) #go through the env_list and find what we are looking for
    {
      if (is.na(env_list[i]) == TRUE || is.logical(env_list[i])) #if we get something weird like this we need to throw an error
      {
        out = NULL # this cannot be false yet because we don't know if the user wants to try again
        skip = TRUE
        break
      }
      if (env_list[i] == label) #we found it!
      {
        pos = i
      }
    }
    
    if (!skip) #make sure we didn't get something weird, then try to get the value
      out = try(get(label, pos, envir=.GlobalEnv), silent = TRUE)
    
    if (is.null(out)) #if we got a null we got a problem becuase nothing that (currently) uses this function wants a null
    {
      writeLines("Warning: Value is null or does not exist.")
      loop = logical.prompt("Do you want to try again? ")
      if (loop == FALSE)
      {
        out = FALSE
      }
    } else if (!is.null(attr(out, "class")))
    { ## handles other errors
      if (((attr(out, "class") == "try-error") == TRUE) && (is.data.frame(out) == FALSE) || typeof(out) == "closure")
      {
        writeLines("Warning: Value does not exist or some other problem occured.")
        loop = logical.prompt("Do you want to try again? ")
        if (loop == FALSE)
        {
          out = FALSE
        }
      } else
      {
        loop = FALSE
      }
    } else #no problems, we are good to go
    {
      loop = FALSE
    }
  }
  writeLines("")
  return(out)
}