goodfit.predict <- function(x, type = c("poisson", "binomial", "nbinomial"), method = c("ML", "MinChisq"), par = NULL,
                    newcount = NULL, predict.type = c("response", "prob"), interactive = FALSE)
{
  if (interactive == FALSE && !missing(x))
  {
    out = list()
  
    result = try(vcd::goodfit(x, type, method, par), silent = TRUE) #performs the test in third party function
    if (!is.null(attr(result, "class")))
    {
      if ((attr(result, "class") == "try-error") == TRUE)
      {
        return(result)
      }
    }
    
    predresult = try(predict(result, newcount, predict.type), silent = TRUE) #performs the test in third party function
    if (!is.null(attr(predresult, "class")))
    {
      if ((attr(predresult, "class") == "try-error") == TRUE)
      {
        return(predresult)
      }
    }
  
    out$goodfit = result
    out$predict = predresult
  
    return(out) #out: out$goodfit, out$predict
  } else
  {
    out <- execute.cli("goodfit.predict")
    return(out)
  }
}
