goodfit.predict.gui <- function()
{
  out = NULL
  
  text.entry <- function()
  {
    ok <- function() ######### gets user input
    {
      ## MUST USE NAMES IN RETURNVAL FOR DO.CALL
      returnval$x <<- tclvalue(x)
      returnval$type <<- tclvalue(type)
      returnval$method <<- tclvalue(method)
      returnval$par <<- tclvalue(par)
      returnval$newcount <<- tclvalue(newcount)
      returnval$predict.type <<- tclvalue(predict.type)
      
      eval = list()
      
      for (i in seq(6))
      {
        eval[[i]] = list()
      }
      
      eval[[1]] = vector.gui(returnval$x)
      
      eval[[2]]$value = returnval$type
      if (!(eval[[2]]$value == "poisson" || eval[[2]]$value == "binomial" || eval[[2]]$value == "nbinomial"))
      {
        eval[[2]]$loop = TRUE
      } else
      {
        eval[[2]]$loop = FALSE
      }
      
      eval[[3]]$value = returnval$method
      if (!(eval[[3]]$value == "ML" || eval[[3]]$value == "MinChisq"))
      {
        eval[[3]]$loop = TRUE
      } else
      {
        eval[[3]]$loop = FALSE
      }
      
      eval[[4]]$value = returnval$par
      if (eval[[4]]$value == "")
      {
        eval[[4]]$value = NULL
        eval[[4]]$loop = FALSE
      } else
      {
        eval[[4]]$value = as.list(noquote(returnval$par))
        eval[[4]]$loop = FALSE
      }
      
      eval[[5]] = numeric.optional.gui(returnval$newcount)
      
      eval[[6]]$value = returnval$predict.type
      if (!(eval[[6]]$value == "response" || eval[[6]]$value == "prob"))
      {
        eval[[6]]$loop = TRUE
      } else
      {
        eval[[6]]$loop = FALSE
      }
      
      for (i in seq(6))
      {
        if (eval[[i]]$loop == TRUE) ###### NOTE: Do not use tkdestroy() here because that will cancel the wait, which prevents data re-entry
        {
          errorText = paste("Something is wrong in argument number ", i,
                            " . Note that some fields, including optional fields. are dependent on others. ", sep = "")
          tkmessageBox(message = errorText, icon = "error")
          returnval <<- NULL
          break
        }
      }
      
      if (!is.null(returnval))
      {
        if (!(returnval[1] == "Cancel"))
        {
          returnval$x <<- eval[[1]]$value
          returnval$type <<- eval[[2]]$value
          returnval$method <<- eval[[3]]$value
          returnval$par <<- eval[[4]]$value
          returnval$newcount <<- eval[[5]]$value
          returnval$predict.type <<- eval[[6]]$value
          
          tkdestroy(win)
        }
      }
      
    }
    
    cancel <- function() ######## cancels
    {
      returnval[1] <<- "Cancel"
      
      tkdestroy(win)
    }
    
    ###################################################### creating the window
    
    win = tktoplevel()
    tkwm.title(win, "goodfit.predict")
    tkwm.geometry(win, "+100+100")
    
    x = tclVar(paste("")) #v in Var is capital
    text.x = ttkentry(win, width = paste(50), textvariable = x)
    
    type = tclVar(paste(""))
    text.type = ttkentry(win, width = paste(10), textvariable = type)
    
    method = tclVar(paste(""))
    text.method = ttkentry(win, width = paste(10), textvariable = method)
    
    par = tclVar(paste(""))
    text.par = ttkentry(win, width = paste(50), textvariable = par)
    
    newcount = tclVar(paste(""))
    text.newcount = ttkentry(win, width = paste(20), textvariable = newcount)
    
    predict.type = tclVar(paste("response"))
    text.predict.type = ttkentry(win, width = paste(10), textvariable = predict.type)
    
    
    tkgrid(ttklabel(win, text = "1. A Numeric Vector of the Data: "), text.x, sticky = "we")
    tkgrid(ttklabel(win, text = "2. Which Distribution should be fit (poisson, binomial, nbinomial)? "), text.type, sticky = "we")
    tkgrid(ttklabel(win, text = "3. Which method should be used to fit the distribution (ML, MinChisq)? "), text.method, sticky = "we")
    tkgrid(ttklabel(win, text = "4. A named list giving the distribution paramaters (Optional): "), text.par, sticky = "we")
    tkgrid(ttklabel(win, text = "5. A number which selects which prediction to return (Optional): "), text.newcount, sticky = "we")
    tkgrid(ttklabel(win, text = "6. Return the response or the probability of the response (response, prob)? "), text.predict.type, sticky = "we")
    
    ok.button = ttkbutton(win, text = "Ok", command = ok)
    cancel.button = ttkbutton(win, text = "Cancel", command = cancel)
    
    tkgrid(ok.button, cancel.button, sticky = "we")
    
    returnval = list()
    
    tkfocus(win)
    tkwait.window(win)
    return(returnval)
  }
  
  ##################################### getting user input
  value = text.entry()
  
  ############### cancel action
  if (value[[1]] == "Cancel")
  {
    return(FALSE)
  }
  
  result = do.call(HypoTest::goodfit.predict, value)
  
  out <<- result
  
  print(result)
}