interactive.cli <- function(Which_Statistic=NULL, Sigma_or_Prob_Known=NULL, Sum_or_Data=NULL,
                            Num_Samples=NULL, Small_or_Large=NULL, Dep_or_Indep=NULL)
{
  
  enableJIT(3)
  
  #function_decision on lines 7-103, enough_information on lines 110-277
  
  function_decision <- function()
  {
    if(Quant_or_Cat=="Quant") #QUANTITATIVE*******************************************
    {
      if(Which_Statistic=="Mean" || Which_Statistic=="Mu")
      {
        if(Num_Samples=="1" || Num_Samples=="2" || Num_Samples == FALSE)
        {
          if(Sigma_or_Prob_Known=="Yes" || Sigma_or_Prob_Known==TRUE)
          {
            if(Sum_or_Data=="Sum")
            {
              return("zsum.test")
            } else if (Sum_or_Data=="Data")
            {
              return("z.test")
            }
          } else if (Sigma_or_Prob_Known=="No" || Sigma_or_Prob_Known==FALSE)
          {
            if(Sum_or_Data=="Sum")
            {
              return("tsum.test")
            } else if (Sum_or_Data=="Data")
            {
              return("t.test")
            }
          }
        } else if (Num_Samples=="Many" || Num_Samples == TRUE)
        {
          return("aov")
        }
      } else if (Which_Statistic=="Sigma")
      {
        if(Sum_or_Data=="Sum")
        {
          return("sigmasum.test")
        } else if (Sum_or_Data=="Data")
        {
          return("sigma.test")
        }
      } else if (Which_Statistic=="Var" || Which_Statistic=="Variance Ratio" || Which_Statistic == "Variance")
      {
        if(Sum_or_Data=="Sum")
        {
          return("varsum.test")
        } else if (Sum_or_Data=="Data")
        {
          return("var.test")
        }
      } else if (Which_Statistic=="Regression")
      {
        return("lm")
      }
    } else if (Quant_or_Cat=="Cat") #CATEGORIAL*****************************************
    {
      if(Which_Statistic=="Prop" || Which_Statistic=="Proportion")
      {
        if(Num_Samples=="1")
        {
          if(Small_or_Large=="Small")
          {
            return("binom.test")
          } else if (Small_or_Large=="Large" || is.null(Small_or_Large))
          {
            return("prop.test")
          }
        } else if (Num_Samples=="2")
        {
          if(Dep_or_Indep=="Dep")
          {
            return("mcnemar.test")
          } else if (Dep_or_Indep=="Indep")
          {
            return("prop.test")
          }
        } else if (Num_Samples=="Many")
        {
          return("chisq.test")
        }
      } else if (Which_Statistic=="Indep" || Which_Statistic=="Independence")
      {
        return("chisq.test")
      } else if (Which_Statistic=="Fitness")
      {
        if (Sigma_or_Prob_Known=="Yes" || Sigma_or_Prob_Known==TRUE)
        {
          return("chisq.test")
        } else if (Sigma_or_Prob_Known=="No" || Sigma_or_Prob_Known==FALSE)
        {
          return("goodfit.predict")
        }
      } else if (Which_Statistic == "Distribution" || Which_Statistic == "Distro")
      {
        return("ks.test")
      }
    }
  } 
  
  
  #end of function_decision ************************************&&&&&&&&&&&&&&&&&&&&&&&***********************************
  
  # basically go through all the information, if it is null fill it in (branches out so we don't need every piece)
  
  enough_information <- function() #make sure all necessary information is available
  {

    if(is.null(Which_Statistic))
    {
      Which_Statistic <<- readline("What kind of test do you want (Mean/Sigma/Var/Regression/Prop/Indep/Fitness/Distro): ")
      writeLines("")
      return(FALSE)
      
    } else if (Which_Statistic=="Mean" || Which_Statistic=="Mu")
    { ## turned out we didn't need Quant_or_Cat but since this was here from the beginning and its in the structure I just left it
      Quant_or_Cat<<-"Quant"
      
      if(is.null(Num_Samples))
      {
        Num_Samples <<- logical.prompt("Do you have more than 2 samples? ")
        return(FALSE)
        
      } else if (Num_Samples==FALSE)
      {
        if(is.null(Sigma_or_Prob_Known) || is.null(Sum_or_Data))
        {
          if (is.null(Sigma_or_Prob_Known))
          {
            Sigma_or_Prob_Known <<- logical.prompt("Do you know sigma? ")
          }
          if (is.null(Sum_or_Data))
          {
            Sum_or_Data <<- readline("Do you have summary statistics or data (Sum/Data): ")
          }
          return(FALSE)
        } else if(Sigma_or_Prob_Known=="Yes" || Sigma_or_Prob_Known=="No" || Sigma_or_Prob_Known==TRUE || Sigma_or_Prob_Known==FALSE)
        {
          if(Sum_or_Data=="Sum" || Sum_or_Data=="Data")
          {
            return(TRUE)
          } else
          {
            Sum_or_Data <<- readline("There is a typo: Do you have summary statistics or data (Sum/Data): ")
            return(FALSE)
          }
        } else
          {
            Sigma_or_Prob_Known <<- logical.prompt("There is a typo: Do you know sigma? ")
            return(FALSE)
          }
      } else if (Num_Samples==TRUE)
      {
        return(TRUE)
      } else
      {
        Num_Samples <<- logical.prompt("There is a typo: Do you have more than two samples? ")
        return(FALSE)
      }
    } else if (Which_Statistic=="Sigma")
    {
      Quant_or_Cat<<-"Quant"
      
      if(is.null(Sum_or_Data))
      {
        Sum_or_Data <<- readline("Do you have summary statistics or data (Sum/Data): ")
        return(FALSE)
        
      } else if (Sum_or_Data=="Sum" || Sum_or_Data=="Data")
      {
        return(TRUE)
      } else
      {
        Sum_or_Data <<- readline("There is a typo: Do you have summary statistics or data (Sum/Data): ")
        return(FALSE)
      }
    } else if (Which_Statistic=="Var" || Which_Statistic=="Variance Ratio" || Which_Statistic == "Variance")
    {
      Quant_or_Cat<<-"Quant"
      
      if(is.null(Sum_or_Data))
      {
        Sum_or_Data <<- readline("Do you have summary statistics or data (Sum/Data): ")
        return(FALSE)
      } else if (Sum_or_Data=="Sum" || Sum_or_Data=="Data")
      {
        return(TRUE)
      } else
      {
        Sum_or_Data <<- readline("There is a typo: Do you have summary statistics or data (Sum/Data): ")
        return(FALSE)
      }
    } else if (Which_Statistic=="Regression")
    {
      Quant_or_Cat<<-"Quant"
      return(TRUE)
    } else if (Which_Statistic=="Prop" || Which_Statistic=="Proportion")
    {
      Quant_or_Cat<<-"Cat"
      
      if (is.null(Num_Samples))
      {
        Num_Samples <<- readline("How many samples are there (1/2/Many): ")
        return(FALSE)
        
      } else if (Num_Samples=="1")
      {
        if (is.null(Small_or_Large))
        {
          Small_or_Large <<- readline("Do you have large or small sample data (Small/Large): ")
          return(FALSE)
          
        } else if (Small_or_Large=="Small" || Small_or_Large=="Large")
        {
          return(TRUE)
        } else
        {
          Small_or_Large <<- readline("There is a typo: Do you have large or small sample data (Small/Large): ")
          return(FALSE)
        }
      } else if (Num_Samples=="2")
      {
        if (is.null(Dep_or_Indep))
        {
          Dep_or_Indep <<- readline("Are your samples dependent or independent of each other (Dep/Indep): ")
          return(FALSE)
          
        } else if (Dep_or_Indep=="Dep" || Dep_or_Indep=="Indep")
        {
          return(TRUE)
        } else
        {
          Dep_or_Indep = ("There is a typo: Are your samples dependent or independent (Dep/Indep): ")
          return(FALSE)
        }
      } else if (Num_Samples=="Many")
      {
        return(TRUE)
      } else
      {
        Num_Samples <<- readline("There is a typo: How many samples are there (1/2/Many): ")
        return(FALSE)
      }
    } else if (Which_Statistic=="Indep" || Which_Statistic=="Independence")
    {
      Quant_or_Cat<<-"Cat"
      
      return(TRUE)
    } else if (Which_Statistic=="Fitness")
    {
      Quant_or_Cat<<-"Cat"
      
      if (is.null(Sigma_or_Prob_Known))
      {
        Sigma_or_Prob_Known <<- logical.prompt("Do you know the probabilities? ")
        return(FALSE)
      } else if (Sigma_or_Prob_Known=="Yes" || Sigma_or_Prob_Known=="No" || Sigma_or_Prob_Known==TRUE || Sigma_or_Prob_Known==FALSE)
      {
        return(TRUE)
      } else
      {
        Sigma_or_Prob_Known <<- logical.prompt("There is a typo: Do you know the probabilities? ")
        return(FALSE)
      }
    } else if (Which_Statistic=="Distribution" || Which_Statistic == "Distro")
    {
      Quant_or_Cat<<-"Cat"
      return(TRUE)
    } else
    {
      Which_Statistic <<- readline("There is a typo: Which test do you want (Mean/Sigma/Var/Regression/Prop/Indep/Fitness/Distro): ")
      writeLines("")
      return(FALSE)
    }
  } #end of enough_information ********************************&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&***************************
  
  out = list()
  
  Quant_or_Cat = NULL
  
  cat("\014")
  writeLines("Press escape key at any time to exit.")
  writeLines("")
  writeLines("Please be aware that all input is case sensitive.")
  writeLines("")
  
  rerun_interactive = TRUE
  while(rerun_interactive)
  {
    
    loop = FALSE
    while(!loop)
    {
      loop = enough_information() #first find out if we have enough information to send a name to execute.cli, if not, repeat
    }
    name = function_decision() #we have enough information, now we need to know what that name actually is
    
    writeLines(paste("The name of the test is ", name, ".", sep = ""))
    try(Sys.sleep(2))
    output <- execute.cli(name) # let's actually do the function and get back some results
    
    if (name == "aov" || name == "lm")
    {
      print(summary(output))
    } else
    {
      print(output)
    }
    
    out = append(out, name) # if we repeat this function, we can append our results together so the user doesn't loose any
    out = append(out, output)
    
    exit = logical.prompt("Do you want to exit? If you want to change the statistical test, there is no need to exit. ")
    if (exit == TRUE)
    {
      return(invisible(out))
    }
    same_test = logical.prompt("Do you want to perform the same statistical test? ")
    cat("\014")
    if (same_test == FALSE)
    { # we need to reset all of these so we can start fresh
      rerun_interactive = TRUE
      Quant_or_Cat = NULL
      Which_Statistic = NULL
      Sigma_or_Prob_Known = NULL
      Sum_or_Data = NULL
      Num_Samples = NULL
      Small_or_Large = NULL
      Dep_or_Indep = NULL
      
      writeLines("")
      writeLines("Please be aware that all input is case sensitive.")
      writeLines("")
    }
  }
  
  
}