ks.test <- function(x, y, ..., alternative = "two.sided", conf.level = 0.95, exact = NULL, interactive = FALSE)
{ 
  if (interactive == FALSE && !missing(x))
  {
    argg <- c(as.list(environment()), list(...)) #gets all of the stuff that the user passed in along with those dots
    argg$conf.level <- NULL # we aren't passing these along so let's get rid of them
    argg$interactive <- NULL
    alpha = 1 - conf.level
  
    out = list()
  
    result = try(do.call(stats::ks.test, argg), silent = TRUE) #calls the function using all the stuff except conf.level and interactive
    if (!is.null(attr(result, "class")))
    {
      if ((attr(result, "class") == "try-error") == TRUE)
      {
        return(result)
      }
    }
    
    out$test.statistic <- as.numeric(result$statistic)
    out$p.value <- result$p.value
    out$alternative <- alternative
  
    if (out$p.value < alpha)
    {
      out$decision <- "Reject Null (accept alternative)"
    } else
    {
      out$decision <- "Null Hypothesis Possible (reject alternative)"
    }
  
    return(out) #out: out$test.statistic, p.value, alternative, decision
  } else
  {
    out <- execute.cli("ks.test")
    return(out)
  }
}