ks.test.gui <- function()
{
  out = NULL
  
  text.entry <- function()
  {
    ok <- function() ######### gets user input
    {
      ## MUST USE NAMES IN RETURNVAL FOR DO.CALL
      returnval$x <<- tclvalue(x)
      returnval$y <<- tclvalue(y)
      returnval$... <<- tclvalue(dots)
      returnval$alternative <<- tclvalue(alternative)
      returnval$conf.level <<- tclvalue(conf.level)
      returnval$exact <<- tclvalue(exact)
      
      eval = list()
      
      for (i in seq(6))
      {
        eval[[i]] = list()
      }
      
      eval[[1]] = vector.gui(returnval$x)
      eval[[2]]$value = returnval$y #this means no typo checking on y or dots
      eval[[2]]$loop = FALSE
      
      if (!returnval$... == "")
      {
        eval[[3]]$value = as.numeric(returnval$...)
        if (is.na(eval[[3]]$value))
        {
          eval[[3]]$loop = TRUE
        } else
        {
          eval[[3]]$loop = FALSE
        }
      } else
      {
        eval[[3]]$value = ""
        eval[[3]]$loop = FALSE
      }
      
      eval[[4]] = alternative.gui(returnval$alternative)
      eval[[5]] = conf.level.gui(returnval$conf.level)
      eval[[6]] = logical.optional.gui(returnval$exact)
      
      for (i in seq(6))
      {
        if (eval[[i]]$loop == TRUE) ###### NOTE: Do not use tkdestroy() here because that will cancel the wait, which prevents data re-entry
        {
          errorText = paste("Something is wrong in argument number ", i,
                            " . Note that some fields, including optional fields. are dependent on others. ", sep = "")
          tkmessageBox(message = errorText, icon = "error")
          returnval <<- NULL
          break
        }
      }
      
      if (!is.null(returnval))
      {
        if (!(returnval[1] == "Cancel"))
        {
          returnval$x <<- eval[[1]]$value
          returnval$y <<- eval[[2]]$value
          returnval$... <<- eval[[3]]$value
          returnval$alternative <<- eval[[4]]$value
          returnval$conf.level <<- eval[[5]]$value
          returnval$exact <<- eval[[6]]$value
          
          tkdestroy(win)
        }
      }
      
    }
    
    cancel <- function() ######## cancels
    {
      returnval[1] <<- "Cancel"
      
      tkdestroy(win)
    }
    
    ###################################################### creating the window
    
    win = tktoplevel()
    tkwm.title(win, "ks.test")
    tkwm.geometry(win, "+100+100")
    
    x = tclVar(paste("")) #v in Var is capital
    text.x = ttkentry(win, width = paste(50), textvariable = x)
    
    y = tclVar(paste(""))
    text.y = ttkentry(win, width = paste(50), textvariable = y)
    
    dots = tclVar(paste(""))
    text.dots = ttkentry(win, width = paste(20), textvariable = dots)
    
    alternative = tclVar(paste("two.sided"))
    text.alternative = ttkentry(win, width = paste(10), textvariable = alternative)
    
    conf.level = tclVar(paste("0.95"))
    text.conf.level = ttkentry(win, width = paste(10), textvariable = conf.level)
    
    exact = tclVar(paste(""))
    text.exact = ttkentry(win, width = paste(10), textvariable = exact)
    
    tkgrid(ttklabel(win, text = "1. A Numeric Vector of the Data: "), text.x, sticky = "we")
    tkgrid(ttklabel(win, text = "2. Either a Numeric Vector of the Second Data or the Name of CDF (no typo checking): "), text.y, sticky = "we")
    tkgrid(ttklabel(win, text = "3. A SINGLE Numeric Paramter for the CDF (no typo checking, optional): "), text.dots, sticky = "we")
    tkgrid(ttklabel(win, text = "4. Alternative Hypothesis: "), text.alternative, sticky = "we")
    tkgrid(ttklabel(win, text = "5. Confidence Level: "), text.conf.level, sticky = "we")
    tkgrid(ttklabel(win, text = "6. Do you want to get the exact P value (Optional)? "), text.exact, sticky = "we")
    
    ok.button = ttkbutton(win, text = "Ok", command = ok)
    cancel.button = ttkbutton(win, text = "Cancel", command = cancel)
    
    tkgrid(ok.button, cancel.button, sticky = "we")
    
    returnval = list()
    
    tkfocus(win)
    tkwait.window(win)
    return(returnval)
  }
  
  ##################################### getting user input
  value = text.entry()
  
  ############### cancel action
  if (value[[1]] == "Cancel")
  {
    return(FALSE)
  }
  
  if (value[[3]] != "")
  {
    result = HypoTest::ks.test(x = value$x, y = value$y, value[[3]],
                              alternative = value$alternative, conf.level = value$conf.level, exact = value$exact)
  } else
  {
    result = HypoTest::ks.test(x = value$x, y = value$y, alternative = value$alternative, conf.level = value$conf.level,
                               exact = value$exact)
  }

  out <<- result
  
  print(result)
}