mcnemar.test <- function(x, y = NULL, correct = TRUE, conf.level = 0.95, interactive = FALSE)
{
  if (interactive == FALSE && !missing(x))
  {
    alpha = 1 - conf.level
  
    out = list()
  
    result = try(stats::mcnemar.test(x, y, correct), silent = TRUE) #performs the test in third party function
    if (!is.null(attr(result, "class")))
    {
      if ((attr(result, "class") == "try-error") == TRUE)
      {
        return(result)
      }
    }
    out$test.statistic <- as.numeric(result$statistic)
    out$p.value <- result$p.value
    out$alternative <- "Probabilities are not the same"
  
    if (out$p.value < alpha)
    {
      out$decision <- "Reject Null (accept alternative)"
    } else
    {
      out$decision <- "Null Hypothesis Possible (reject alternative)"
    }
  
    out$df <- as.numeric(result$parameter)
    return(out)  #out: out$test.statistic, p.value, alternative, decision
  } else
  {
    out <- execute.cli("mcnemar.test")
    return(out)
  }
}
