mcnemar.test.gui <- function()
{
  out = NULL
  
  text.entry <- function()
  {
    ok <- function() ######### gets user input
    {
      ## MUST USE NAMES IN RETURNVAL FOR DO.CALL
      returnval$x <<- tclvalue(x)
      returnval$correct <<- tclvalue(correct)
      returnval$conf.level <<- tclvalue(conf.level)
      
      eval = list()
      
      for (i in seq(4))
      {
        eval[[i]] = list()
      }
      
      eval[[1]] = vector.gui(returnval$x)
      eval[[2]] = integer.gui(tclvalue(row))
      eval[[3]] = logical.gui(returnval$correct)
      eval[[4]] = conf.level.gui(returnval$conf.level)
      
      for (i in seq(4))
      {
        if (eval[[i]]$loop == TRUE) ###### NOTE: Do not use tkdestroy() here because that will cancel the wait, which prevents data re-entry
        {
          errorText = paste("Something is wrong in argument number ", i,
                            " . Note that some fields, including optional fields. are dependent on others. ", sep = "")
          tkmessageBox(message = errorText, icon = "error")
          returnval <<- NULL
          break
        }
      }
      
      if (!is.null(returnval))
      {
        if (!(returnval[1] == "Cancel"))
        {
          eval[[1]]$value = matrix(eval[[1]]$value, nrow = eval[[2]]$value)
          
          returnval$x <<- eval[[1]]$value
          returnval$correct <<- eval[[3]]$value
          returnval$conf.level <<- eval[[4]]$value
          
          tkdestroy(win)
        }
      }
      
    }
    
    cancel <- function() ######## cancels
    {
      returnval[1] <<- "Cancel"
      
      tkdestroy(win)
    }
    
    ###################################################### creating the window
    
    win = tktoplevel()
    tkwm.title(win, "mcnemar.test")
    tkwm.geometry(win, "+100+100")
    
    x = tclVar(paste("")) #v in Var is capital
    text.x = ttkentry(win, width = paste(50), textvariable = x)
    
    row = tclVar(paste(""))
    text.row = ttkentry(win, width = paste(20), textvariable = row)
    
    correct = tclVar(paste("TRUE"))
    text.correct = ttkentry(win, width = paste(10), textvariable = correct)
    
    conf.level = tclVar(paste("0.95"))
    text.conf.level = ttkentry(win, width = paste(10), textvariable = conf.level)
    
    
    tkgrid(ttklabel(win, text = "1. A Numeric Vector that will be converted to a Matrix by column: "), text.x, sticky = "we")
    tkgrid(ttklabel(win, text = "2. How many rows are in this matrix? "), text.row, sticky = "we")
    tkgrid(ttklabel(win, text = "3. Should Continuity Correction be Applied? "), text.correct, sticky = "we")
    tkgrid(ttklabel(win, text = "4. Confidence Level: "), text.conf.level, sticky = "we")
    
    ok.button = ttkbutton(win, text = "Ok", command = ok)
    cancel.button = ttkbutton(win, text = "Cancel", command = cancel)
    
    tkgrid(ok.button, cancel.button, sticky = "we")
    
    returnval = list()
    
    tkfocus(win)
    tkwait.window(win)
    return(returnval)
  }
  
  ##################################### getting user input
  value = text.entry()
  
  ############### cancel action
  if (value[[1]] == "Cancel")
  {
    return(FALSE)
  }
  
  result = do.call(HypoTest::mcnemar.test, value)
  
  out <<- result
  
  print(result)
}