numeric.gui <- function(value)
{
  out = list()
  out$value = as.numeric(value)
  if (is.na(out$value))
  {
    out$loop = TRUE
  } else
  {
    out$loop = FALSE
  }
  return(out)
}

numeric.optional.gui <- function(value, depends = NULL) # this var does not have to be supplied unless depends; if it is, must be numeric
{
  if (value == "" && is.null(depends)) #handles case where no value given and depend var does not exist
  {
    out = list()
    out$value = NULL
    out$loop = FALSE
    return(out)
  } else if (value != "" && is.null(depends)) # handles case where value is given and depend var does not exist
  {
    return(numeric.gui(value))
  } else
  { # handles case where depend var does exist
    out = list()
    if (depends$loop == TRUE) #if the depend var is bad, it won't matter what value this guy is
    {
      out$loop = TRUE
      return(out)
    } else # if the depend var is good, make this a numeric
    {
      if (is.null(depends$value)) # if depends doesn't have any data, this variable doesn't need data either
      {
        out$loop = FALSE
        return(out)
      } else
      {
        return(numeric.gui(value))
      }
    }
  }
}