prop.test <- function(x, n = NULL, p = 0.5, alternative = "two.sided", conf.level = 0.95, correct = TRUE, interactive = FALSE)
{
  if (interactive == FALSE && !missing(x))
  {
    alpha = 1 - conf.level
  
    out = list()
  
    if (length(x) > 1 && length(n) > 1)
    {
      p = NULL
    }
  
    result = try(stats::prop.test(x, n, p, alternative, conf.level, correct), silent = TRUE) #performs the test in third party function
    if (!is.null(attr(result, "class")))
    {
      if ((attr(result, "class") == "try-error") == TRUE)
      {
        return(result)
      }
    }
    out$test.statistic <- as.numeric(result$statistic)
    out$p.value <- result$p.value
    out$alternative <- alternative
  
    if (out$p.value < alpha)
    {
      out$decision <- "Reject Null (accept alternative)"
    } else
    {
      out$decision <- "Null Hypothesis Possible (reject alternative)"
    }
  
    out$conf.int <- c(result$conf.int[1], result$conf.int[2])
  
    return(out)  #out: out$test.statistic, p.value, alternative, decision, conf.int
  } else
  {
    out <- execute.cli("prop.test")
    return(out)
  }
}
