prop.test.gui <- function()
{
  out = NULL
  
  text.entry <- function()
  {
    ok <- function() ######### gets user input
    {
      ## MUST USE NAMES IN RETURNVAL FOR DO.CALL
      returnval$x <<- tclvalue(x)
      returnval$n <<- tclvalue(n)
      returnval$p <<- tclvalue(p)
      returnval$alternative <<- tclvalue(alternative)
      returnval$conf.level <<- tclvalue(conf.level)
      returnval$correct <<- tclvalue(correct)
      
      eval = list()
      
      for (i in seq(6))
      {
        eval[[i]] = list()
      }
      
      eval[[1]] = vector.gui(returnval$x)
      eval[[2]] = vector.gui(returnval$n)
      eval[[3]] = vector.optional.gui(returnval$p)
      
      if (eval[[3]]$loop == FALSE && !is.null(eval[[3]]$value)) # make sure all probs between 0 and 1
      {
        for (i in seq(length(eval[[3]]$value)))
        {
          if (eval[[3]]$value[i] > 1 || eval[[3]]$value[i] < 0)
          {
            eval[[3]]$loop = TRUE
            break
          }
        }
      }
      
      eval[[4]] = alternative.gui(returnval$alternative)
      eval[[5]] = conf.level.gui(returnval$conf.level)
      eval[[6]] = logical.optional.gui(returnval$correct)
      
      for (i in seq(6))
      {
        if (eval[[i]]$loop == TRUE) ###### NOTE: Do not use tkdestroy() here because that will cancel the wait, which prevents data re-entry
        {
          errorText = paste("Something is wrong in argument number ", i,
                            " . Note that some fields, including optional fields. are dependent on others. ", sep = "")
          tkmessageBox(message = errorText, icon = "error")
          returnval <<- NULL
          break
        }
      }
      
      if (!is.null(returnval))
      {
        if (!(returnval[1] == "Cancel"))
        {
          returnval$x <<- eval[[1]]$value
          returnval$n <<- eval[[2]]$value
          returnval$p <<- eval[[3]]$value
          returnval$alternative <<- eval[[4]]$value
          returnval$conf.level <<- eval[[5]]$value
          returnval$correct <<- eval[[6]]$value
          
          tkdestroy(win)
        }
      }
      
    }
    
    cancel <- function() ######## cancels
    {
      returnval[1] <<- "Cancel"
      
      tkdestroy(win)
    }
    
    ###################################################### creating the window
    
    win = tktoplevel()
    tkwm.title(win, "prop.test")
    tkwm.geometry(win, "+100+100")
    
    x = tclVar(paste("")) #v in Var is capital
    text.x = ttkentry(win, width = paste(50), textvariable = x)
    
    n = tclVar(paste(""))
    text.n = ttkentry(win, width = paste(50), textvariable = n)
    
    p = tclVar(paste(""))
    text.p = ttkentry(win, width = paste(50), textvariable = p)
    
    alternative = tclVar(paste("two.sided"))
    text.alternative = ttkentry(win, width = paste(10), textvariable = alternative)
    
    conf.level = tclVar(paste("0.95"))
    text.conf.level = ttkentry(win, width = paste(10), textvariable = conf.level)
    
    correct = tclVar(paste("TRUE"))
    text.correct = ttkentry(win, width = paste(10), textvariable = correct)
    
    tkgrid(ttklabel(win, text = "1. A Numeric Vector of Successes: "), text.x, sticky = "we")
    tkgrid(ttklabel(win, text = "2. A Numeric Vector of Number of Trials: "), text.n, sticky = "we")
    tkgrid(ttklabel(win, text = "3. A Numeric Vector of Probabilities: "), text.p, sticky = "we")
    tkgrid(ttklabel(win, text = "4. Alternative Hypothesis: "), text.alternative, sticky = "we")
    tkgrid(ttklabel(win, text = "5. Confidence Level: "), text.conf.level, sticky = "we")
    tkgrid(ttklabel(win, text = "6. Should Continuity Correction be Applied? "), text.correct, sticky = "we")
    
    ok.button = ttkbutton(win, text = "Ok", command = ok)
    cancel.button = ttkbutton(win, text = "Cancel", command = cancel)
    
    tkgrid(ok.button, cancel.button, sticky = "we")
    
    returnval = list()
    
    tkfocus(win)
    tkwait.window(win)
    return(returnval)
  }
  
  ##################################### getting user input
  value = text.entry()
  
  ############### cancel action
  if (value[[1]] == "Cancel")
  {
    return(FALSE)
  }
  
  result = do.call(HypoTest::prop.test, value)
  
  out <<- result
  
  print(result)
}