sigmasum.test.gui <- function()
{
  out = NULL
  
  text.entry <- function()
  {
    ok <- function() ######### gets user input
    {
      ## MUST USE NAMES IN RETURNVAL FOR DO.CALL
      returnval$n <<- tclvalue(n)
      returnval$s <<- tclvalue(s)
      returnval$sigmasq <<- tclvalue(sigmasq)
      returnval$alternative <<- tclvalue(alternative)
      returnval$conf.level <<- tclvalue(conf.level)
      
      eval = list()
      
      for (i in seq(5))
      {
        eval[[i]] = list()
      }
      
      eval[[1]] = integer.gui(returnval$n)
      eval[[2]] = numeric.optional.gui(returnval$s)
      eval[[3]] = numeric.optional.gui(returnval$sigmasq)
      eval[[4]] = alternative.gui(returnval$alternative)
      eval[[5]] = conf.level.gui(returnval$conf.level)
      
      for (i in seq(5))
      {
        if (eval[[i]]$loop == TRUE) ###### NOTE: Do not use tkdestroy() here because that will cancel the wait, which prevents data re-entry
        {
          errorText = paste("Something is wrong in argument number ", i,
                            " . Note that some fields, including optional fields. are dependent on others. ", sep = "")
          tkmessageBox(message = errorText, icon = "error")
          returnval <<- NULL
          break
        }
      }
      
      if (!is.null(returnval))
      {
        if (!(returnval[1] == "Cancel"))
        {
          returnval$n <<- eval[[1]]$value
          returnval$s <<- eval[[2]]$value
          returnval$sigmasq <<- eval[[3]]$value
          returnval$alternative <<- eval[[4]]$value
          returnval$conf.level <<- eval[[5]]$value
          
          tkdestroy(win)
        }
      }
      
    }
    
    cancel <- function() ######## cancels
    {
      returnval[1] <<- "Cancel"
      
      tkdestroy(win)
    }
    
    ###################################################### creating the window
    
    win = tktoplevel()
    tkwm.title(win, "sigmasum.test")
    tkwm.geometry(win, "+100+100")
    
    n = tclVar(paste("")) #v in Var is capital
    text.n = ttkentry(win, width = paste(20), textvariable = n)
    
    s = tclVar(paste("1"))
    text.s = ttkentry(win, width = paste(20), textvariable = s)
    
    sigmasq = tclVar(paste("1"))
    text.sigmasq = ttkentry(win, width = paste(20), textvariable = sigmasq)
    
    alternative = tclVar(paste("two.sided"))
    text.alternative = ttkentry(win, width = paste(10), textvariable = alternative)
    
    conf.level = tclVar(paste("0.95"))
    text.conf.level = ttkentry(win, width = paste(10), textvariable = conf.level)
    
    tkgrid(ttklabel(win, text = "1. The Sample Size: "), text.n, sticky = "we")
    tkgrid(ttklabel(win, text = "2. Sample Standard Deviation (Optional): "), text.s, sticky = "we")
    tkgrid(ttklabel(win, text = "3. Hypothesized Variance (Optional): "), text.sigmasq, sticky = "we")
    tkgrid(ttklabel(win, text = "4. Alternative Hypothesis: "), text.alternative, sticky = "we")
    tkgrid(ttklabel(win, text = "5. Confidence Level: "), text.conf.level, sticky = "we")
    
    ok.button = ttkbutton(win, text = "Ok", command = ok)
    cancel.button = ttkbutton(win, text = "Cancel", command = cancel)
    
    tkgrid(ok.button, cancel.button, sticky = "we")
    
    returnval = list()
    
    tkfocus(win)
    tkwait.window(win)
    return(returnval)
  }
  
  ##################################### getting user input
  value = text.entry()
  
  ############### cancel action
  if (value[[1]] == "Cancel")
  {
    return(FALSE)
  }
  
  result = do.call(HypoTest::sigmasum.test, value)
  
  out <<- result
  
  print(result)
}