t.test.gui <- function()
{
  out = NULL
  
  text.entry <- function()
  {
    ok <- function() ######### gets user input
    {
      
      ## MUST USE NAMES IN RETURNVAL FOR DO.CALL
      returnval$x <<- tclvalue(x)
      returnval$y <<- tclvalue(y)
      returnval$mu <<- tclvalue(mu)
      returnval$alternative <<- tclvalue(alternative)
      returnval$paired <<- tclvalue(paired)
      returnval$var.equal <<- tclvalue(var.equal)
      returnval$conf.level <<- tclvalue(conf.level)
      
      eval = list()
      
      for (i in seq(7))
      {
        eval[[i]] = list()
      }
      
      eval[[1]] = vector.gui(returnval$x)
      eval[[2]] = vector.optional.gui(returnval$y)
      eval[[3]] = numeric.optional.gui(returnval$mu)
      eval[[4]] = alternative.gui(returnval$alternative)
      eval[[5]] = logical.optional.gui(returnval$paired, depends = eval[[2]])
      eval[[6]] = logical.optional.gui(returnval$var.equal, depends = eval[[2]])
      eval[[7]] = conf.level.gui(returnval$conf.level)
      
      for (i in seq(7))
      {
        if (eval[[i]]$loop == TRUE) ###### NOTE: Do not use tkdestroy() here because that will cancel the wait, which prevents data re-entry
        {
          errorText = paste("Something is wrong in argument number ", i,
                            " . Note that some fields, including optional fields. are dependent on others. ", sep = "")
          tkmessageBox(message = errorText, icon = "error")
          returnval <<- NULL
          break
        }
      }
      
      if (!is.null(returnval))
      {
        if (!(returnval[1] == "Cancel"))
        {
          returnval$x <<- eval[[1]]$value
          returnval$y <<- eval[[2]]$value
          returnval$mu <<- eval[[3]]$value
          returnval$alternative <<- eval[[4]]$value
          returnval$paired <<- eval[[5]]$value
          returnval$var.equal <<- eval[[6]]$value
          returnval$conf.level <<- eval[[7]]$value
          
          tkdestroy(win)
        }
      }
    }
    
    cancel <- function() ######## cancels
    {
      returnval[1] <<- "Cancel"
      
      tkdestroy(win)
    }
    
    ###################################################### creating the window
    
    win = tktoplevel()
    tkwm.title(win, "t.test")
    tkwm.geometry(win, "+100+100")
    
    x = tclVar(paste("")) #v in Var is capital
    text.x = ttkentry(win, width = paste(50), textvariable = x)
    
    y = tclVar(paste(""))
    text.y = ttkentry(win, width = paste(50), textvariable = y)
    
    mu = tclVar(paste("0"))
    text.mu = ttkentry(win, width = paste(20), textvariable = mu)
    
    alternative = tclVar(paste("two.sided"))
    text.alternative = ttkentry(win, width = paste(10), textvariable = alternative)
    
    paired = tclVar(paste("FALSE"))
    text.paired = ttkentry(win, width = paste(10), textvariable = paired)
    
    var.equal = tclVar(paste("FALSE"))
    text.var.equal = ttkentry(win, width = paste(10), textvariable = var.equal)
    
    conf.level = tclVar(paste("0.95"))
    text.conf.level = ttkentry(win, width = paste(10), textvariable = conf.level)
    
    tkgrid(ttklabel(win, text = "1. A Numeric Vector of the Data: "), text.x, sticky = "we")
    tkgrid(ttklabel(win, text = "2. A Numeric Vector of the Second Data (Optional): "), text.y, sticky = "we")
    tkgrid(ttklabel(win, text = "3. The Hypothesized Mean or Difference in Means (Optional): "), text.mu, sticky = "we")
    tkgrid(ttklabel(win, text = "4. Alternative Hypothesis: "), text.alternative, sticky = "we")
    tkgrid(ttklabel(win, text = "5. Is the Data Dependent (Optional)? "), text.paired, sticky = "we")
    tkgrid(ttklabel(win, text = "6. Are the Variances Equal (Optional)? "), text.var.equal, sticky = "we")
    tkgrid(ttklabel(win, text = "7. Confidence Level: "), text.conf.level, sticky = "we")
    
    ok.button = ttkbutton(win, text = "Ok", command = ok)
    cancel.button = ttkbutton(win, text = "Cancel", command = cancel)
    
    tkgrid(ok.button, cancel.button, sticky = "we")
    
    returnval = list()
    
    tkfocus(win)
    tkwait.window(win)
    return(returnval)
  }
  
  ##################################### getting user input
  value = text.entry()
  
  ############### cancel action
  if (value[[1]] == "Cancel")
  {
    return(FALSE)
  }
  
  result = do.call(HypoTest::t.test, value)
  
  out <<- result
  
  print(result)
}