tsum.test <- function(n.x, mean.x, s.x, n.y = NULL, mean.y = NULL, s.y = NULL, mu = 0, alternative = "two.sided", 
                      var.equal = FALSE, conf.level = 0.95, interactive = FALSE)
{
  if (interactive == FALSE && !missing(n.x) && !missing(mean.x) && !missing(s.x))
  {
    alpha = 1 - conf.level
  
    out = list()
  
    #performs the test in third party function
    result = try(PASWR::tsum.test(mean.x, s.x, n.x, mean.y, s.y, n.y, alternative, mu, var.equal, conf.level), silent = TRUE)
    if (!is.null(attr(result, "class")))
    {
      if ((attr(result, "class") == "try-error") == TRUE)
      {
        return(result)
      }
    }
    out$test.statistic <- as.numeric(result$statistic)
    out$p.value <- result$p.value
    out$alternative <- alternative
    
    if (out$p.value < alpha)
    {
      out$decision <- "Reject Null (accept alternative)"
    } else
    {
      out$decision <- "Null Hypothesis Possible (reject alternative)"
    }
  
    out$conf.int <- c(result$conf.int[1], result$conf.int[2])
    out$df <- as.numeric(result$parameters)
  
    return(out) #out: out$test.statistic, p.value, alternative, decision, conf.int, df
  } else
  {
    out <- execute.cli("tsum.test")
    return(out)
  }
}