tsum.test.gui <- function()
{
  out = NULL
  
  text.entry <- function()
  {
    ok <- function() ######### gets user input
    {
      ## MUST USE NAMES IN RETURNVAL FOR DO.CALL
      returnval$n.x <<- tclvalue(n.x)
      returnval$mean.x <<- tclvalue(mean.x)
      returnval$s.x <<- tclvalue(s.x)
      returnval$n.y <<- tclvalue(n.y)
      returnval$mean.y <<- tclvalue(mean.y)
      returnval$s.y <<- tclvalue(s.y)
      returnval$mu <<- tclvalue(mu)
      returnval$alternative <<- tclvalue(alternative)
      returnval$var.equal <<- tclvalue(var.equal)
      returnval$conf.level <<- tclvalue(conf.level)
      
      eval = list()
      
      for (i in seq(10))
      {
        eval[[i]] = list()
      }
      
      eval[[1]] = integer.gui(returnval$n.x)
      eval[[2]] = numeric.gui(returnval$mean.x)
      eval[[3]] = numeric.gui(returnval$s.x)
      eval[[4]] = integer.optional.gui(returnval$n.y)
      eval[[5]] = numeric.optional.gui(returnval$mean.y, eval[[4]])
      eval[[6]] = numeric.optional.gui(returnval$s.y, eval[[5]])
      eval[[7]] = numeric.optional.gui(returnval$mu)
      eval[[8]] = alternative.gui(returnval$alternative)
      eval[[9]] = logical.optional.gui(returnval$var.equal)
      eval[[10]] = conf.level.gui(returnval$conf.level)
      
      for (i in seq(10))
      {
        if (eval[[i]]$loop == TRUE) ###### NOTE: Do not use tkdestroy() here because that will cancel the wait, which prevents data re-entry
        {
          errorText = paste("Something is wrong in argument number ", i,
                            " . Note that some fields, including optional fields. are dependent on others. ", sep = "")
          tkmessageBox(message = errorText, icon = "error")
          returnval <<- NULL
          break
        }
      }
      
      if (!is.null(returnval))
      {
        if (!(returnval[1] == "Cancel"))
        {
          returnval$n.x <<- eval[[1]]$value
          returnval$mean.x <<- eval[[2]]$value
          returnval$s.x <<- eval[[3]]$value
          returnval$n.y <<- eval[[4]]$value
          returnval$mean.y <<- eval[[5]]$value
          returnval$s.y <<- eval[[6]]$value
          returnval$mu <<- eval[[7]]$value
          returnval$alternative <<- eval[[8]]$value
          returnval$var.equal <<- eval[[9]]$value
          returnval$conf.level <<- eval[[10]]$value
          
          tkdestroy(win)
        }
      }
      
    }
    
    cancel <- function() ######## cancels
    {
      returnval[1] <<- "Cancel"
      
      tkdestroy(win)
    }
    
    ###################################################### creating the window
    
    win = tktoplevel()
    tkwm.title(win, "tsum.test")
    tkwm.geometry(win, "+100+100")
    
    n.x = tclVar(paste("")) #v in Var is capital
    text.n.x = ttkentry(win, width = paste(20), textvariable = n.x)
    
    mean.x = tclVar(paste(""))
    text.mean.x = ttkentry(win, width = paste(20), textvariable = mean.x)
    
    s.x = tclVar(paste(""))
    text.s.x = ttkentry(win, width = paste(20), textvariable = s.x)
    
    n.y = tclVar(paste(""))
    text.n.y = ttkentry(win, width = paste(20), textvariable = n.y)
    
    mean.y = tclVar(paste(""))
    text.mean.y = ttkentry(win, width = paste(20), textvariable = mean.y)
    
    s.y = tclVar(paste(""))
    text.s.y = ttkentry(win, width = paste(20), textvariable = s.y)
    
    mu = tclVar(paste("0"))
    text.mu = ttkentry(win, width = paste(20), textvariable = mu)
    
    alternative = tclVar(paste("two.sided"))
    text.alternative = ttkentry(win, width = paste(10), textvariable = alternative)
    
    var.equal = tclVar(paste("FALSE"))
    text.var.equal = ttkentry(win, width = paste(10), textvariable = var.equal)
    
    conf.level = tclVar(paste("0.95"))
    text.conf.level = ttkentry(win, width = paste(10), textvariable = conf.level)
    
    tkgrid(ttklabel(win, text = "1. The Sample Size: "), text.n.x, sticky = "we")
    tkgrid(ttklabel(win, text = "2. The Sample Mean: "), text.mean.x, sticky = "we")
    tkgrid(ttklabel(win, text = "3. The Population Standard Deviation: "), text.s.x, sticky = "we")
    tkgrid(ttklabel(win, text = "4. The Second Sample Size (Optional): "), text.n.y, sticky = "we")
    tkgrid(ttklabel(win, text = "5. The Second Sample Mean (Optional): "), text.mean.y, sticky = "we")
    tkgrid(ttklabel(win, text = "6. The Second Population Standard Deviation (Optional): "), text.s.y, sticky = "we")
    tkgrid(ttklabel(win, text = "7. The Hypothesized Mean or Difference in Means (Optional): "), text.mu, sticky = "we")
    tkgrid(ttklabel(win, text = "8. Alternative Hypothesis: "), text.alternative, sticky = "we")
    tkgrid(ttklabel(win, text = "9. Are the Variances Equal (Optional)? "), text.var.equal, sticky = "we")
    tkgrid(ttklabel(win, text = "10. Confidence Level: "), text.conf.level, sticky = "we")
    
    ok.button = ttkbutton(win, text = "Ok", command = ok)
    cancel.button = ttkbutton(win, text = "Cancel", command = cancel)
    
    tkgrid(ok.button, cancel.button, sticky = "we")
    
    returnval = list()
    
    tkfocus(win)
    tkwait.window(win)
    return(returnval)
  }
  
  ##################################### getting user input
  value = text.entry()
  
  ############### cancel action
  if (value[[1]] == "Cancel")
  {
    return(FALSE)
  }
  
  result = do.call(HypoTest::tsum.test, value)
  
  out <<- result
  
  print(result)
}