var.test <- function(x, y, ratio = 1, alternative = "two.sided", conf.level = 0.95, interactive = FALSE)
{
  if (interactive == FALSE && !missing(x) && !missing(y))
  {
    alpha = 1 - conf.level
  
    out = list()
  
    result = try(stats::var.test(x, y, ratio, alternative, conf.level), silent = TRUE) #performs the test in third party function
    if (!is.null(attr(result, "class")))
    {
      if ((attr(result, "class") == "try-error") == TRUE)
      {
        return(result)
      }
    }
    out$test.statistic <- as.numeric(result$statistic)
    out$p.value <- result$p.value
    out$alternative <- alternative
  
    if (out$p.value < alpha)
    {
      out$decision <- "Reject Null (accept alternative)"
    } else
    {
      out$decision <- "Null Hypothesis Possible (reject alternative)"
    }
  
    out$conf.int <- c(result$conf.int[1], result$conf.int[2])
  
    out$df <- as.numeric(result$parameter)
    return(out) #out$test.statistic, p.value, alternative, decision, conf.int, df
  } else
  {
    out <- execute.cli("var.test")
    return(out)
  }
}
