var.test.gui <- function()
{
  out = NULL
  
  text.entry <- function()
  {
    ok <- function() ######### gets user input
    {
      ## MUST USE NAMES IN RETURNVAL FOR DO.CALL
      returnval$x <<- tclvalue(x)
      returnval$y <<- tclvalue(y)
      returnval$ratio <<- tclvalue(ratio)
      returnval$alternative <<- tclvalue(alternative)
      returnval$conf.level <<- tclvalue(conf.level)
      
      eval = list()
      
      for (i in seq(5))
      {
        eval[[i]] = list()
      }
      
      eval[[1]] = vector.gui(returnval$x)
      eval[[2]] = vector.gui(returnval$y)
      eval[[3]] = numeric.optional.gui(returnval$ratio)
      eval[[4]] = alternative.gui(returnval$alternative)
      eval[[5]] = conf.level.gui(returnval$conf.level) ### this will later need to be changed to 0 < x < 1
      
      for (i in seq(5))
      {
        if (eval[[i]]$loop == TRUE) ###### NOTE: Do not use tkdestroy() here because that will cancel the wait, which prevents data re-entry
        {
          errorText = paste("Something is wrong in argument number ", i,
                            " . Note that some fields, including optional fields. are dependent on others. ", sep = "")
          tkmessageBox(message = errorText, icon = "error")
          returnval <<- NULL
          break
        }
      }
      
      if (!is.null(returnval))
      {
        if (!(returnval[1] == "Cancel"))
        {
          returnval$x <<- eval[[1]]$value
          returnval$y <<- eval[[2]]$value
          returnval$ratio <<- eval[[3]]$value
          returnval$alternative <<- eval[[4]]$value
          returnval$conf.level <<- eval[[5]]$value
          
          tkdestroy(win)
        }
      }
      
    }
    
    cancel <- function() ######## cancels
    {
      returnval[1] <<- "Cancel"
      
      tkdestroy(win)
    }
    
    ###################################################### creating the window
    
    win = tktoplevel()
    tkwm.title(win, "var.test")
    tkwm.geometry(win, "+100+100")
    
    x = tclVar(paste("")) #v in Var is capital
    text.x = ttkentry(win, width = paste(50), textvariable = x)
    
    y = tclVar(paste(""))
    text.y = ttkentry(win, width = paste(50), textvariable = y)
    
    ratio = tclVar(paste("1"))
    text.ratio = ttkentry(win, width = paste(20), textvariable = ratio)
    
    alternative = tclVar(paste("two.sided"))
    text.alternative = ttkentry(win, width = paste(10), textvariable = alternative)
    
    conf.level = tclVar(paste("0.95"))
    text.conf.level = ttkentry(win, width = paste(10), textvariable = conf.level)
    
    tkgrid(ttklabel(win, text = "1. A Numeric Vector of the Data: "), text.x, sticky = "we")
    tkgrid(ttklabel(win, text = "2. A Numeric Vector of the Second Data: "), text.y, sticky = "we")
    tkgrid(ttklabel(win, text = "3. Hypothesized Ratio (Optional): "), text.ratio, sticky = "we")
    tkgrid(ttklabel(win, text = "4. Alternative Hypothesis: "), text.alternative, sticky = "we")
    tkgrid(ttklabel(win, text = "5. Confidence Level: "), text.conf.level, sticky = "we")
    
    ok.button = ttkbutton(win, text = "Ok", command = ok)
    cancel.button = ttkbutton(win, text = "Cancel", command = cancel)
    
    tkgrid(ok.button, cancel.button, sticky = "we")
    
    returnval = list()
    
    tkfocus(win)
    tkwait.window(win)
    return(returnval)
  }
  
  ##################################### getting user input
  value = text.entry()
  
  ############### cancel action
  if (value[[1]] == "Cancel")
  {
    return(FALSE)
  }
  
  result = do.call(HypoTest::var.test, value)
  
  out <<- result
  
  print(result)
}