varsum.test.gui <- function()
{
  out = NULL
  
  text.entry <- function()
  {
    ok <- function() ######### gets user input
    {
      ## MUST USE NAMES IN RETURNVAL FOR DO.CALL
      returnval$n.x <<- tclvalue(n.x)
      returnval$s.x <<- tclvalue(s.x)
      returnval$n.y <<- tclvalue(n.y)
      returnval$s.y <<- tclvalue(s.y)
      returnval$ratio <<- tclvalue(ratio)
      returnval$alternative <<- tclvalue(alternative)
      returnval$conf.level <<- tclvalue(conf.level)
      
      eval = list()
      
      for (i in seq(7))
      {
        eval[[i]] = list()
      }
      
      eval[[1]] = integer.gui(returnval$n.x)
      eval[[2]] = numeric.gui(returnval$s.x)
      eval[[3]] = integer.gui(returnval$n.y)
      eval[[4]] = numeric.gui(returnval$s.y)
      eval[[5]] = numeric.optional.gui(returnval$ratio)
      eval[[6]] = alternative.gui(returnval$alternative)
      eval[[7]] = conf.level.gui(returnval$conf.level)
      
      for (i in seq(7))
      {
        if (eval[[i]]$loop == TRUE) ###### NOTE: Do not use tkdestroy() here because that will cancel the wait, which prevents data re-entry
        {
          errorText = paste("Something is wrong in argument number ", i,
                            " . Note that some fields, including optional fields. are dependent on others. ", sep = "")
          tkmessageBox(message = errorText, icon = "error")
          returnval <<- NULL
          break
        }
      }
      
      if (!is.null(returnval))
      {
        if (!(returnval[1] == "Cancel"))
        {
          returnval$n.x <<- eval[[1]]$value
          returnval$s.x <<- eval[[2]]$value
          returnval$n.y <<- eval[[3]]$value
          returnval$s.y <<- eval[[4]]$value
          returnval$ratio <<- eval[[5]]$value
          returnval$alternative <<- eval[[6]]$value
          returnval$conf.level <<- eval[[7]]$value
          
          tkdestroy(win)
        }
      }
      
    }
    
    cancel <- function() ######## cancels
    {
      returnval[1] <<- "Cancel"
      
      tkdestroy(win)
    }
    
    ###################################################### creating the window
    
    win = tktoplevel()
    tkwm.title(win, "varsum.test")
    tkwm.geometry(win, "+100+100")
    
    n.x = tclVar(paste("")) #v in Var is capital
    text.n.x = ttkentry(win, width = paste(20), textvariable = n.x)
    
    s.x = tclVar(paste(""))
    text.s.x = ttkentry(win, width = paste(20), textvariable = s.x)
    
    n.y = tclVar(paste(""))
    text.n.y = ttkentry(win, width = paste(20), textvariable = n.y)
    
    s.y = tclVar(paste(""))
    text.s.y = ttkentry(win, width = paste(20), textvariable = s.y)
    
    ratio = tclVar(paste("1"))
    text.ratio = ttkentry(win, width = paste(20), textvariable = ratio)
    
    alternative = tclVar(paste("two.sided"))
    text.alternative = ttkentry(win, width = paste(10), textvariable = alternative)
    
    conf.level = tclVar(paste("0.95"))
    text.conf.level = ttkentry(win, width = paste(10), textvariable = conf.level)
    
    tkgrid(ttklabel(win, text = "1. The Sample Size: "), text.n.x, sticky = "we")
    tkgrid(ttklabel(win, text = "2. The Sample Standard Deviation: "), text.s.x, sticky = "we")
    tkgrid(ttklabel(win, text = "3. The Second Sample Size: "), text.n.y, sticky = "we")
    tkgrid(ttklabel(win, text = "4. The Second Sample Standard Deviation: "), text.s.y, sticky = "we")
    tkgrid(ttklabel(win, text = "5. Hypothesized Ratio (Optional): "), text.ratio, sticky = "we")
    tkgrid(ttklabel(win, text = "6. Alternative Hypothesis: "), text.alternative, sticky = "we")
    tkgrid(ttklabel(win, text = "7. Confidence Level: "), text.conf.level, sticky = "we")
    
    ok.button = ttkbutton(win, text = "Ok", command = ok)
    cancel.button = ttkbutton(win, text = "Cancel", command = cancel)
    
    tkgrid(ok.button, cancel.button, sticky = "we")
    
    returnval = list()
    
    tkfocus(win)
    tkwait.window(win)
    return(returnval)
  }
  
  ##################################### getting user input
  value = text.entry()
  
  ############### cancel action
  if (value[[1]] == "Cancel")
  {
    return(FALSE)
  }
  
  result = do.call(HypoTest::varsum.test, value)
  
  out <<- result
  
  print(result)
}