vector.gui <- function(value)
{
  out = list()
  
  value = strsplit(value, ",") #split the string
  value = unlist(value) #make it so we can play with it
  out$value = as.numeric(value) #turn it into numbers
  
  for (i in seq(length(out$value)))
  {
    if (is.na(out$value[i])) #check for any failed number conversions
    {
      out$loop = TRUE
      break
    } else
    {
      out$loop = FALSE
    }
  }
  return(out)
}

vector.optional.gui <- function(value, depends = NULL)
{
  if (value == "" && is.null(depends)) #handles case where no value given and depend var does not exist
  {
    out = list()
    out$value = NULL
    out$loop = FALSE
    return(out)
  } else if (value != "" && is.null(depends)) # handles case where value is given and depend var does not exist
  {
    return(vector.gui(value))
  } else
  { # handles case where depend var does exist
    out = list()
    if (depends$loop == TRUE) #if the depend var is bad, it won't matter what value this guy is
    {
      out$loop = TRUE
      return(out)
    } else # if the depend var is good, make this a numeric vector
    {
      if (is.null(depends$value)) # if depends doesn't have any data, this variable doesn't need data either
      {
        out$loop = FALSE
        return(out)
      } else
      {
        return(vector.gui(value))
      }
    }
  }
}