z.test = function(x, sigma.x = NULL, y=NULL, sigma.y = NULL, mu = 0, alternative = "two.sided", conf.level = 0.95,
                  interactive = FALSE)
{
  if (interactive == FALSE && !missing(x))
    {
    alpha = 1 - conf.level
  
    out = list()
  
    #performs the test in third party function
    result = try(PASWR::z.test(x, y, alternative = "two.sided", mu, sigma.x, sigma.y, conf.level), silent = TRUE)
    if (!is.null(attr(result, "class")))
    {
      if ((attr(result, "class") == "try-error") == TRUE)
      {
        return(result)
      }
    }
    out$test.statistic <- as.numeric(result$statistic)
    out$p.value <- result$p.value[1]
    out$alternative <- alternative
  
    if (out$p.value < alpha)
    {
      out$decision <- "Reject Null (accept alternative)"
    } else
    {
      out$decision <- "Null Hypothesis Possible (reject alternative)"
    }
  
    out$conf.int <- c(result$conf.int[1], result$conf.int[2])
  
    return(out) #out: out$test.statistic, p.value, alternative, decision, conf.int
  } else
  {
    out <- execute.cli("z.test")
    return(out)
  }
}
