zsum.test <- function(n.x, mean.x, sigma.x, n.y = NULL, mean.y = NULL, sigma.y = NULL, mu = 0,
                      alternative = "two.sided", conf.level = 0.95, interactive = FALSE)
{
  if (interactive == FALSE && !missing(n.x) && !missing(mean.x) && !missing(sigma.x))
  {
    alpha = 1 - conf.level
  
    out = list()
  
    result = try(PASWR::zsum.test(mean.x, sigma.x, n.x, mean.y, sigma.y, n.y, alternative, mu, conf.level), silent = TRUE)
    if (!is.null(attr(result, "class")))
    {
      if ((attr(result, "class") == "try-error") == TRUE)
      {
        return(result)
      }
    }
    out$test.statistic <- as.numeric(result$statistic)
    out$p.value <- result$p.value
    out$alternative <- alternative
  
    if (out$p.value < alpha)
    {
      out$decision <- "Reject Null (accept alternative)"
    } else
    {
      out$decision <- "Null Hypothesis Possible (reject alternative)"
    }
  
    out$conf.int <- c(result$conf.int[1], result$conf.int[2])
  
    return(out) #out$test.statistic, p.value, alternative, decision, conf.int
  } else
  {
    out <- execute.cli("zsum.test")
    return(out)
  }
}
