\name{conf.level.gui}
\alias{conf.level.gui}
\title{
Graphical User Interface: Confidence Level Validation
}
\description{This function takes text input, converts it to numeric, tests if the number is between 0 and 1, and reports if the conversion was a success or failure. It is intended to be executed by other GUI functions.
}
\usage{
conf.level.gui(value)
}
\arguments{
\item{value}{the text string to convert}
}
\details{
Uses the same conversion from text to numeric as \code{\link{numeric.prompt}}. Then checks if the number is between 0 and 1 using almost the same test as \link{conf.level.prompt}. Also tests if the conversion was successful.
}
\value{
  \item{out$result}{The converted number or \code{NULL} if the conversion failed.}
  \item{out$loop}{A logical, \code{TRUE} for a success and \code{FALSE} for a failure.}
}

\keyword{gui}