\name{factor.prompt}
\alias{factor.prompt}
\title{
Interactively Gets a Factor
}
\description{This function is primarily intended to support other functions in interactive mode, but may also be called by the user at any time. An interactive function that either creates a factor or loads a factor from the global environment.
}
\usage{
factor.prompt(prompt = NULL)
}
\arguments{
  \item{prompt}{a character vector or \code{NULL}. Used to inform the user in interactive mode what the data being entered will be used for.}
}
\details{
Asks the user a logical question with \link{logical.prompt} to determine how the factor should be created or loaded. Uses \link{global.env} to load an existing factor. Uses \link{vector.prompt} if creating a factor manually both for the data and, optionally, for the levels.
}
\value{
  \item{out}{Returns a created factor, a factor loaded from the global environment.}
}

\keyword{interactive}
