\name{integer.gui}
\alias{integer.gui}
\alias{integer.optional.gui}
\title{
Graphical User Interface: Integer Validation
}
\description{This function takes text input, converts it to numeric, checks if the number is an integer, and reports if the conversion was a success or failure. It is intended to be executed by other GUI functions.
}
\usage{
integer.gui(value)
integer.optional.gui(value, depends = NULL)
}
\arguments{
\item{value}{the text string to convert}
\item{depends}{any other variable that this value relies on. If depends is not supplied, this value does not have to be supplied. If depends is supplied and is good, the normal conversion takes place. If depends is supplied and is bad, this value is automatically declared bad.}
}
\details{
Uses the same conversion from text to numeric as \code{\link{numeric.gui}}. Then checks if the value is an integer using the same method in \link{integer.prompt}. Also tests if the conversion was successful.
}
\value{
  \item{out$result}{The converted number or \code{NULL} if the conversion failed.}
  \item{out$loop}{A logical, \code{TRUE} for a success and \code{FALSE} for a failure.}
}

\keyword{gui}