\name{lm}
\alias{lm}
\title{Interface for Fitting Linear Models}
\description{
  User friendly, but limited, implementation of \code{\link[stats]{lm}}.
  Fits linear models.
}
\usage{
# lm()

lm(formula,
    data = NULL,
    interactive = FALSE)

}
\arguments{
  If no arguments are passed, the function will enter interactive mode.
  \item{formula}{an object of class formula that specifies the model.}
  \item{data}{a data frame in which the variables specified in formula will be found.}
  \item{interactive}{a logical. If TRUE, all other arguments are ignored and
  the function will enter interactive mode. Control is transferred to 
  \code{\link{function.execute.cli}}.}
}
\details{
  Takes the above input parameters and passes them to \code{\link[stats]{lm}}.
  Note that many arguments cannot be changed. Will return an object.
}
\value{
  An object that \code{\link[stats]{lm}} returns, usually of class c("lm").
  
  Will return an object of class "try-error" if an error is encountered in \code{\link[stats]{lm}}.
}

\seealso{
  \code{\link[stats]{lm}} for the function that implements the
  fit.
}
\examples{
\dontrun{
If we have the following dataframe called data:
   Score GPA Method
1   79.4   H      F
2   84.7   H      F
3   92.0   H      F
4   90.4   H      F
5   84.1   M      F
6   85.0   M      F
7   77.1   M      F
8   84.0   M      F
9   83.7   L      F
10  86.6   L      F
11  83.1   L      F
12  81.3   L      F
13  91.2   H      O
14  91.0   H      O
15  93.1   H      O
16  88.6   H      O
17  72.0   M      O
18  85.2   M      O
19  77.6   M      O
20  75.2   M      O
21  75.5   L      O
22  74.5   L      O
23  80.1   L      O
24  79.9   L      O
25  86.8   H      H
26  87.1   H      H
27  89.0   H      H
28  90.2   H      H
29  86.1   M      H
30  90.4   M      H
31  87.2   M      H
32  88.6   M      H
33  76.8   L      H
34  80.7   L      H
35  75.5   L      H
36  80.6   L      H
37  83.1   H      V
38  92.4   H      V
39  93.3   H      V
40  80.7   H      V
41  78.1   M      V
42  81.7   M      V
43  80.1   M      V
44  79.8   M      V
45  81.2   L      V
46  83.6   L      V
47  78.8   L      V
48  78.5   L      V

Our formula parameter will be Score~GAP+Method.

## Method
out <- lm(Score~GPA+Method, data = data)

## Result
## Call:
## NULL

## Coefficients:
## (Intercept)         GPAL         GPAM      MethodH      MethodO      MethodV  
##     89.1458      -8.2875      -6.3000       0.6333      -2.2917      -1.6750

## Note that other values exist and are not displayed.
}
}
\keyword{fit}
