\name{logical.gui}
\alias{logical.gui}
\alias{logical.optional.gui}
\title{
Graphical User Interface: Numeric Validation
}
\description{This function takes text input, checks if it is \code{TRUE} or \code{FALSE}, and reports if the comparison was a success or failure. It is intended to be executed by other GUI functions.
}
\usage{
logical.gui(value)
logical.optional.gui(value, depends = NULL)
}
\arguments{
\item{value}{the text string to compare}
\item{depends}{any other variable that this value relies on. If depends is not supplied, this value does not have to be supplied. If depends is supplied and is good, the normal conversion takes place. If depends is supplied and is bad, this value is automatically declared bad.}
}
\details{
Uses a test for equality with the words "TRUE", "Yes", "FALSE", and "No".
}
\value{
  \item{out$result}{A logical or \code{NULL} if the conversion failed.}
  \item{out$loop}{A logical that represents if the input text was an acceptable value, \code{TRUE} for a success and \code{FALSE} for a failure.}
}

\keyword{gui}