\name{matrix.prompt}
\alias{matrix.prompt}
\title{
Interactively Loads or Creates a Matrix
}
\description{This function is primarily intended to support other functions in interactive mode, but may also be called by the user at any time. An interactive function that either creates a matrix from a vector or loads a matrix from the global environment.
}
\usage{
matrix.prompt(prompt = NULL, byrow = TRUE, square = FALSE)
}
\arguments{
  \item{prompt}{a character vector or \code{NULL}. Used to inform the user in interactive mode what the data being entered will be used for.}
  \item{byrow}{a logical which determines how the matrix should be formed from the vector of data.}
  \item{square}{a logical which determines if square dimension checking should be done on the matrix. Ignored if loading data from a global environment.}
}
\details{
Asks the user a logical question with \link{logical.prompt} to determine how the matrix should be created or loaded. Uses \link{global.env} to load an existing matrix. Uses \link{numeric.prompt}, \link{integer.prompt}, and \link{vector.prompt} if creating a matrix.
}
\value{
  \item{out}{Returns a numeric matrix or a matrix loaded from the global environment.}
}

\keyword{interactive}
