\name{vector.gui}
\alias{vector.gui}
\alias{vector.optional.gui}
\title{
Graphical User Interface: Numeric Vector Validation
}
\description{This function takes text input, converts it to a numeric vector, and reports if the conversion was a success or failure. It is intended to be executed by other GUI functions.
}
\usage{
vector.gui(value)
vector.optional.gui(value, depends = NULL)
}
\arguments{
\item{value}{the text string to convert. Should be numbers separated by commas.}
\item{depends}{any other variable that this value relies on. If depends is not supplied, this value does not have to be supplied. If depends is supplied and is good, the normal conversion takes place. If depends is supplied and is bad, this value is automatically declared bad.}
}
\details{
Uses the same conversion from text to numeric vector as \code{\link{vector.prompt}}. Also tests if the conversion was successful.
}
\value{
  \item{out$result}{The converted numeric vector or \code{NULL} if the conversion failed.}
  \item{out$loop}{A logical, \code{TRUE} for a success and \code{FALSE} for a failure.}
}

\keyword{gui}