\name{vector.prompt}
\alias{vector.prompt}
\title{
Interactively Gets a Vector of Values
}
\description{This function is primarily intended to support other functions in interactive mode, but may also be called by the user at any time. An interactive function that creates a vector, loads a CSV file as a vector, or loads a vector from the global environment.
}
\usage{
vector.prompt(prompt = NULL)
}
\arguments{
  \item{prompt}{a character vector or \code{NULL}. Used to inform the user in interactive mode what the data being entered will be used for.}
}
\details{
Asks the user to determine how the vector should be created or loaded. Uses \link{global.env} to load an existing vector or \link{csv.prompt} to use a CSV file. If using a CSV file, the returned list will be converted to numeric using \code{as.vector(out, mode = "numeric")}. If problems are found in either global environment or CSV loading and the user does not correct these issues, manual vector construction will be required. Requires a comma seperated value list if building a vector manually. Uses \link{strsplit}, \link{unlist}, and \link{as.numeric} on the comma seperated list and checks each element to determine if the inputs are numeric.
}
\value{
  \item{out}{Returns a numeric vector, vector from a CSV, or a vector loaded from the global environment.}
}

\keyword{interactive}
